
import json, sys, socket, time, threading, os
import struct
import socket
import re
import select
import platform, subprocess
import commands


from urllib import urlencode
import urllib2

global clarisse_running
url = "http://localhost:28241/error/"
data = {'error' : "Error exporting to Clarisse, check if Clarisse is running "}

host, port = '127.0.0.1', 24981

livelink_path = os.path.dirname(os.path.dirname(os.path.realpath(__file__)))
if len(sys.argv) > 1:
    livelink_path = sys.argv[1]   

class process_lookup(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)        

    def run(self):
        global clarisse_running
        while True:
            if platform.system().lower() == "windows":
                process_list = subprocess.check_output('tasklist', shell=True)
                if "clarisse.exe" in process_list:
                    # print "Clarisse is running"                    
                    time.sleep(3)
                else:
                    # print "Clarisse is closed"
                    os._exit(1)
                    clarisse_running = False
                    # os.system('taskkill /fi "WindowTitle eq Administrator: MS_ClLiveLink.exe"')
                    sys.exit(1)

            # elif platform.system().lower() == "darwin" or platform.system().lower() == "linux":
            #     process_id = commands.getoutput('pgrep clarisse')                
            #     if len(process_id) == 0:
            #         os._exit(1)
            #         sys.exit()
            #     else:                    
            #         time.sleep(3)



class ClarisseNetError(Exception):
    def __init__(self, command, value):
        self.value = value
        self.command = command

    def __str__(self):
        return '%s\n%s' % (self.value, self.command)

    def get_error(self):
        return '%s\n%s' % (self.value, self.command)


class ClarisseNet:
    class Status:
        Ok = 1
        Error = -1

    class Mode:
        Script = 0
        Statement = 1

    def __init__(self, host="localhost", port=55000):
        
        self.host = "localhost"
        self.port = 55000
        self.status = self.Status.Error        
        try:
            self.connect(host, port)
        except Exception as e:
            print "Connection to calrisse failed"

    def connect(self, host, port):
        
        self.close()
        self.status = self.Status.Error
        try:
            self._socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self._socket.connect((host, port))
        except:
            raise ValueError('Failed to connect to ' + host + ':' + str(port))
        self.status = self.Status.Ok

    def run(self, script):
        if (self.status != self.Status.Ok):
            print "Not connected to Clarisse"
        self._send(script, self.Mode.Script)

    def evaluate(self, statement):
        return self._send(statement, self.Mode.Statement)

    def close(self):
        if (self.status == self.Status.Ok):
            self._socket.close()

    def __del__(self):
        self.close()

    def _send(self, command, mode):
        try:           
            
            if (self.status != self.Status.Ok):                
                # http_post(url, data)
                # time.sleep(1)
                # sys.exit()
                raise RuntimeError('Not connected to Clarisse')
            command_size = len(command) + 1
            command_size = struct.pack("<I", command_size)
            data_sent = self._socket.send(command_size)
            if data_sent == 0:
                print "No data sent"
            packet = str(mode) + command
            data_sent = self._socket.send(packet)
            
            # ready = select.select([_socket], [], [], 1)
            # self._socket.settimeout(12)
            # try:
            #     result_size = self._socket.recv(4)
            # except socket.timeout as e:
            #     http_post(url, data)                
            #     sys.exit()

            result_size = self._socket.recv(4)
            result_size = struct.unpack("<I", result_size)[0]
            must_recv = True
            result = ''
            remaining = result_size
            while (must_recv):
                
                result += self._socket.recv(remaining)
                remaining = result_size - len(result)
                if remaining == 0: must_recv = False

            if (result[0] == '0'):
                
                raise ClarisseNetError(result[1:], command)
            else:
                result = result[1:]
                if (result == ''):                    
                    return None
                else:                    
                    return result

        except Exception as e:
            print "Error running send"


class ms_Init(threading.Thread):
    def __init__(self, importer):
        threading.Thread.__init__(self)
        self.importer = importer

    def run(self):

        print "Starting up..."
        #time.sleep(0.1)
        try:
            print "Making socket on port " + str(port)
            socket_ = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            socket_.bind((host, port))
            print "Socket bound"
            print "Listening to incoming Bridge requests..."
            while True:
                socket_.listen(5)
                client, addr = socket_.accept()
                data = ""
                buffer_size = 4096 * 2
                data = client.recv(buffer_size)
                if data != "":
                    self.TotalData = b""
                    self.TotalData += data
                    while True:
                        data = client.recv(4096 * 2)
                        if data:
                            self.TotalData += data
                        else:
                            self.importer(self.TotalData)
                            break
        except:
            pass


def send_to_command_port(import_data):
    try:
        
        rclarisse = ClarisseNet()        
        import_data = import_data.replace("\\", "\\\\")        
        import_command = 'import sys\n'    
        import_command += 'sys.path.append(r"'+ livelink_path + '")\n'
        import_command += 'from MSLiveLink import SetupPlugin\n\n'
        import_command += 'SetupPlugin.ms_import_asset('+ "'" +  import_data + "'" + ')'        
        rclarisse.run(import_command)
    except Exception as e:
        print "Clarisse send command failed"


def ms_asset_importer(import_data):    
    try:        
        # if platform.system().lower() == "darwin" or platform.system().lower() == "linux":
        #     process_id = commands.getoutput('pgrep clarisse')                
        #     if len(process_id) == 0:
        #         http_post(url, data)             
        #         sys.exit()

        if clarisse_running is False:
            sys.exit()        
        send_to_command_port(import_data) #RW
        threaded_server = ms_Init(ms_asset_importer)
        threaded_server.start()

    except Exception as e:
        print('Error Line : {}'.format(sys.exc_info()[-1].tb_lineno), type(e).__name__, e)
        


print "Running Megascans Bridge client"
clarisse_running = True
t = ms_Init(ms_asset_importer)
t.start()

if platform.system().lower() == "windows":
    plookup = process_lookup()
    plookup.start()

def http_post(url, data):
    req = urllib2.Request('http://localhost:28241/error/', data="Error exporting to Clarisse, check if Clarisse is running", headers={'Content-type': 'text/plain'})
    # post = urlencode(data)
    # req = urllib2.Request(url, post)
    response = urllib2.urlopen(req)

